    Greetings, all!

    I'm well aware that many out there have made and/or used such a mod as
the one I'm presenting you with now but I thought I would pass it on
nonetheless. I use it on my WWIV v4.20e BBS and it works just fine.  It's
purpose is to display your subs (by use of the '*' command) in two orderly
columns, with colours. Note that unlike certain other similar mods, this
one maintains the "<NET>", "[NET]" and the "-" notation so as to let the
user discern whether subs are netted or not and whether they have been
toggled or not for QScan use.

    For the sake of showing what this mod will look like on your BBS, here
is how it is displayed for the regular user on Permanent Waves.  Should you
decide to use, remember to back up your source codes before doing so.  The
actual mod follows on the next post.

			  -=* Subboards Available *=-
 1 -       Main/General Board             2         Entertainment Board
 3         Nonsense/Anonymous Board       4         Comics
 5 -       Trade Wars 2002 Conference     6 -       Mystic Realms
 7 - [NET] Computer Classified            8 - [NET] Computer Problems
 9 - [NET] Computer Programming          10   [NET] Doors & Games
11   [NET] Just For Laughs               12   [NET] Sporting News
13   [NET] Dead Poet Society             14   [NET] Canada Net
15   [NET] West Side                     16   [NET] Painter's Corner
17 - [NET] Trojans and Virii             18   [NET] The Shadow of Armageddon
19   [NET] Prophecy                      20 - [NET] Tolkien's Middle Earth
21   [NET] Keyboards For Christ          22 - [NET] Jewish Issues Sub
23 - [NET] Star Trek Sub                 24 - [NET] Trade Wars 2002 Discussion
AKID3.MOD for WWIV 4.20

Programmed by the Analog Kid, 1@5482
                  of Permanent Waves BBS
                  (514) 844-0214
                  Montreal, Quebec,
                  Canada

Makes a two-column sublist display, with colours.  Simply remove the original
sublist() function in BBS.C and replace it with the following two functions.
Lastly, add the function prototype given below anywhere near the top of the
source (such as before the very first function).

void subline();                /* function prototype for AKID3.MOD */

Functions to be inserted (patch and paste will do it quickly):

void sublist()                   /* AKID3.MOD, by the Analog Kid, 1@5482 */
{                                /* Permanent Waves BBS, Montreal, PQ    */
  int i,abort,right;             /* Followed by function "subline".      */
  char s[160],s1[80];

  nl();
  i=abort=right=0;
  if (thisuser.screenchars<80)
  {
    prt(1,"-=* Subboards Available *=-");
    nl();
    while ((i<MAX_SUBS) && (usub[i].subnum!=-1))
    {
      subline(s1,i);
      pla(s1,&abort);
      i++;
    }
  }
  else
  {
    prt(1,"                          -=* Subboards Available *=-");
    nl();
    while ((i<MAX_SUBS) && (usub[i].subnum!=-1))
    {
      subline(s1,i);
      if (right)
      {
        strcat(s,"    ");
        strcat(s,s1);
        pla(s,&abort);
        right=0;
      }
      else
      {
        strcpy(s,s1);
        right=1;
      }
      i++;
    }
    if (right)
      pla(s,&abort);
  }
  if (i==0)
    pla("None.",&abort);
}

void subline(char s1[43], int i)
{
  sprintf(s1,"%2s - ",usub[i].keys);
  if (usub[i].subnum<32)
  {
    if (!((1L<<(usub[i].subnum)) & thisuser.qscn))
      s1[7]=32;
  }
  else
  {
#if MAX_SUBS>32
    if (!((1L<<(usub[i].subnum-32)) & thisuser.qscn2))
      s1[7]=32;
#else
    s1[7]=32;
#endif
  }
  if (syscfg.systemnumber)
  {
    if (subboards[usub[i].subnum].type)
      if (subboards[usub[i].subnum].anony & anony_val_net)
        strcat(s1,"[NET] ");
      else
        strcat(s1,"<NET> ");
    else
      strcat(s1,"      ");
  }
  strcat(s1,"");
  strcat(s1,subboards[usub[i].subnum].name);
  if (strlen(s1)>45)
    s1[45]=0;
  else
    while (strlen(s1)<=44)
      strcat(s1," ");
}

Disclaimer:  This mod works just fine on Permanent Waves, but in no way can I
be held responsible if its application results in burnt microchips (or human
nerve endings, for that matter), a homicide, drug abuse, the death of your
dog named Fido, or rap music to emanate from your stereo.

Criticism, suggestions, and/or praise are all kindly appreciated.  If this
mod does your board any service and you are pleased with it, please let me
know (and, of course, insert favorite Rush LP into stereo, and play loud).

     For those who have used AKID3.MOD:

     If I may just have your attention for a brief moment... it seems that if 
we upload a mod to a message base and a single line has one "<heart>0" (^C0
or grey) colour imbedded within it (and no other colour code in the same
line), the colour code gets ignored (perhaps because grey is a default
colour?  I'm not sure.) I noticed this with the AKID3.MOD when Bill Swindell
reported some strange error (that I wasn't getting) which displaced certain
subs in the columns with <NET> or [NET] notation.  If someone knows why this
strange grey colour code 'ignoring' occurs, I would greatly appreciate it
being explained to me.

     The only thing that need be done to correct the mod is to simply insert 
two "<heart>0" codes in the locations listed below within the function
subline:

  if (syscfg.systemnumber)
  {
    if (subboards[usub[i].subnum].type)
      if (subboards[usub[i].subnum].anony & anony_val_net)
        strcat(s1,"[NET] ");
      else
        strcat(s1,"<NET> ");
    else
      strcat(s1,"      ");  <---- should read   strcat(s1",<heart>0      ");
  }
  strcat(s1,"");            <---- should read   strcat(s1,"<heart>0");
  strcat(s1,subboards[usub[i].subnum].name);


     where, by <heart>, I mean the control-C symbol that actually appears as
a heart in the IDE environment of C++.
  
     I'm sorry for this inconvenience, but  I wasn't aware that the
"<heart>0" doesn't get saved when uploaded (and consequently, it screws
up the columns a little).  However, once these two tiny additions are made,
all should work fine.
