Joe Barry #1 @6905
2Sunday, 1September 130, 11990  2 5:36 5pm
The Gatekeeper #1 @2461
Wed Jul 25 17:48:18 1990
                             Ŀ                         
                             BATCHUL.MOD
                             07/19/90
                               
INTRODUCTION
  This WWIV modification will allow users to perform batch uploads.  This
mod is different from other batch upload mods in that it will allow filenames
and descriptions to be entered before a transfer.  By using this method a 
user does not have to wait until after the transfer to enter descriptions.
This will be done automatically for them.

HOW IT WORKS
  When a user hits 'U' to upload (or 'Z' to upload to sysop) he
is asked whether or not he wishes to do a batch upload.  If he choose
'Yes' the batch upload mod takes over, if he does not then the upload
process will proceed normally.  Then the user is asked to input the
filenames he wishes to upload (as his terminal/protocol will send them).
When finished the user presses return on a blank line, and the filenames
he enters appear one at a time, at which point the user describes them.
Finally, the user chooses a batch protocol (Zmodem/Ymodem/Ymodem-G/Puma) and
whether or not he wishes to hang up when the transfer is finished. After
the transfer, the batch upload mod will compare the filenames entered to the
new ones that exist in the file directory.  If a file is found that is
different then the ones entered, he will be asked to describe it.  Otherwise
the descriptions he entered before the transfer will be added to the file
directory.

NOTES
 a. It is important to understand that the user must input the exact
    filenames that his protocol will send.  For example :
    
    The user initiates a batch upload.
    He enters the filename NEWDSZ.ZIP and a description of
      NEWEST VERSION OF DSZ - ZMODEM PROTOCOL
    Next the user sends the file in his directory called DSZ0411.ZIP

    After the transfer, the user will be asked to describe the file
    DSZ0411.ZIP, not recognizing the filename he said he was sending.
    The reason being, that DSZ is sent into batch receive mode without 
    knowing what files it is going to receive.  I choose this method
    because it would not be reliable to specify the filenames to receive 
    in a specific order. (The user would end up mixing the files up, etc.)
    
 b. This mod does not provide for extended descriptions.
 c. I have no idea what colors I used in the 'prt(x,' statements, since
    I have a monochrome system; therefore, it may be necessary to change
    these numbers.
 d. All batch uploads go to the current directory the user is in.
 e. If you do not wish to install Puma or Ymodem-G see 'Possible Changes'
    below.
 f. If you do not have the logoffmod (mod author slips my mind) installed
    see 'Possible Changes'

*If you do not need any of the 'Possible Changes', then you can install
 this mod without any alterations, otherwise skip to the end of this
 text.

--------------------------------------------------------------------------
INSTALLATION                  (Note : '=' existing line  '+' add this line)

1. Add the following line to the end of XFER.C
   
   #include "batchul.c"
   
2. Add the following line to the top of XFER.C

=  /* the archive type to use */
=  #define ARC_NUMBER 0
+  void batchul(int dn);                /* mod - add */
=
= int okfn(char *s)

3. Add the following lines to the function void upload(int dn)
   in the file XFER.C

=   pl("Not enough disk space to upload here.");
=   nl();
=   closedl();
=   return;
= }
+ prt(5,"Upload Batch? ");                        /* mod - add */
+ if (yn())                                       /* mod - add */
+  {                                              /* mod - add */
+   closedl();                                    /* mod - add */
+   batchul(dn);                                  /* mod - add */
+  }                                              /* mod - add */
+ else                                            /* mod - add */
+  {                                              /* mod - add */
+   nl();                                         /* mod - add */
= prt(2,"Filename: ");
= input(s,12);

5. At the end of this same function, add a '}' before closedl();

=  }
+  }   /* mod - add */
=  closedl();
=}

6. Create a file named BATCHUL.C containing the following :

-------------------------------------------------------------------------------
/* beginning of file BATCHUL.C */

typedef struct {
 char filename[13],
      description[59];
} batchulrec;

void batch_upload1(int dn);
int batch_upload2(int dn);
int batch_upload3(char *fn,int dn);
void batch_upload4(char *fn, int dn);
int batch_upload5(char *fn, char *ds, int dn);

void batchul(int dn)
{
  int ok,ok1;
  char s[81], s1[81], ch, had;
  double ti;

  nl();
  batch_upload1(dn);
  ok=1; ok1=0;
  while ( (!hangup) && (!ok1) ) {
   nl();
   nl();
   prt(0,"Batch Protocol (?=list) : ");
   ch=onek("?ZYGPAQ");
   switch(ch)
    {
     case '?':
      nl();
      pl("A: Abort");
      pl("Z: Zmodem");
      pl("Y: Ymodem");
      pl("G: Ymodem-G");           /* Noted #1 */
      pl("P: Puma");               /* Noted #2 */
      break;
     case 'Q':
     case 'A': 
      ok=0; ok1=1;
      nl();
      pl("Batch upload aborted.");
      break;
     case 'Z': 
      sprintf(s1,"dsz ha slow rz -m %s",directories[dn].path);
      ok1=1;
      break;
     case 'Y': 
      sprintf(s1,"dsz ha slow rb -k %s",directories[dn].path);
      ok1=1;
      break;
     case 'G':                                                /* Noted #3 */
      sprintf(s1,"dsz ha slow rb -g %s",directories[dn].path);/* Noted #4 */
      ok1=1;                                                  /* Noted #5 */
      break;                                                  /* Noted #6 */
     case 'P':                                                /* Noted #7 */
      sprintf(s1,"puma hs r %s",directories[dn].path);        /* Noted #8 */
      ok1=1;                                                  /* Noted #9 */
      break;                                                  /* Noted #10*/
    }
  }
  nl();
  if ( (ok) && (!hangup) )
   {
    prt(5,"Hang up after transfer (Yes/No/Maybe) ? ");       /* Noted #11*/
    had = onek("YNM");                                       /* Noted #12*/
    nl();
    sprintf(s,"\r\n*=> Current User : %s <==\r\n",nam(&thisuser,usernum));
    outs(s);
    ti=timer();
    set_protect(0);
    run_external(s1);
    ti=timer()-ti;
    if (ti<0) ti += 24.0*3600.0;
    thisuser.extratime += ti;

    nl();
    nl();
    pl("Adding new files to database, please wait.");
    nl();
    batch_upload2(dn);
    nl();
    topscreen();
    if (had=='Y') 
     hangup=1;
    if (had=='M')                                 /* Noted #13 */
     if(logoffmod()==1)                           /* Noted #14 */
      hangup=1;                                   /* Noted #15 */
  }
}

/* get filenames and descriptions from user */
void batch_upload1(int dn)
{
  int ok,i,i1,numup,bfp,nf;
  char s[81],s1[81];
  batchulrec bup[20];

  ok=0;
  i=0;
  nl();
  outstr("Enter filenames to upload now, ");
  prt(5,"using the same filenames your protocol will send.");
  pl("Press RETURN on a blank line to end list or to determine");
  pl("file names automatically.  (Max. 20 files).");
  nl();
  while( (i<20) && (!ok) && (!hangup) ) {
   sprintf(s,"Filename (%2d) : ",i+1);
   outstr(s);
   input(s,12);
   if (!okfn(s))
    continue;
   sprintf(s1,"%s%s",directories[dn].path, s);
   if (exist(s1))
    pl("That file already exists.");
   else
    if(s[0]) {
     align(s);
     for(nf=0,i1=0;i1<i;i1++)
      if (strcmp(s,bup[i1].filename)==0) {
       pl("You already entered that filename.");
       nf=1;
       break;
      }
     if (!nf) {
      strcpy(bup[i].filename, s);
      ++i;
     }
    }
    else
     ok=1;
  }
  numup=i;

  if (numup>0) {
   nl();
   pl("Please enter file descriptions now.");
   nl();
   i=0;
   while ( (!hangup) && (i<numup) ) {
    sprintf(s,"%-13s : ",bup[i].filename);
    outstr(s);
    inputl(s1,58);
    if (s1[0]) {
     strcpy(bup[i].description,s1);
     ++i;
    }
   }
  } else {
   nl();
   prt(5,"Note : You did not enter any filenames.  Therefore, you must"); 
   nl();
   prt(5,"       stay online after the transfer to enter file descriptions."); 
   nl();
   nl();
  }
  remove("batup.dat");
  bfp=open("batup.dat", O_WRONLY | O_CREAT | O_BINARY, S_IREAD | S_IWRITE);
  for(i=0; i<numup; i++)
   write(bfp, (void *)&bup[i], sizeof(batchulrec));
  close(bfp);
}

/* modified uploadall(int dn) function */
int batch_upload2(int dn)
{
  int i,i1,f1,maxf,ok,ocd;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;

  dliscan1(dn);
  ocd=curdir;
  curdir=dn;
  strcpy(s,"*.*");
  strcpy(s1,(directories[dn].path));
  maxf=directories[dn].maxfiles;
  strcat(s1,s);
  f1=findfirst(s1,&ff,0);
  ok=1;
  i1=0;
  while ((f1==0) && (numf<maxf) && (ok) && (!i1)) { 
/* removed (!hangup) */
    strcpy(s,(ff.ff_name));
    align(s);
    i=recno(s);
    if (i==-1) {
      if (!(batch_upload3(s,dn)))
        batch_upload4(s,dn);
    } else {
      SETREC(i);
      read(dlf,(void *)&u, sizeof(uploadsrec));
    }
    f1=findnext(&ff);
  }
  curdir=ocd;
  closedl();
  if (numf>=maxf)
    pl("directory full.");
  return(i1);
}

/* compare new file to files and descriptions input user*/
int batch_upload3(char *fn,int dn)
{
  int bfp,ok,num,i;
  batchulrec batdat;
  
  bfp = open("batup.dat", O_RDONLY | O_BINARY, S_IREAD | S_IWRITE);
  num = filelength(bfp)/sizeof(batchulrec);
  ok=0;
  for (i=0; ( (i<num) && (!ok) ); i++)
   {
    read(bfp, (void*)&batdat, sizeof(batchulrec) );
    if ( strcmp(batdat.filename, fn)==0) { 
     batch_upload5(batdat.filename, batdat.description, dn);
     ok=1;
    }
   }
  close(bfp);
  return(ok);
}

/* get description for unknown file */
void batch_upload4(char *fn, int dn)
{
  char s[81],ds[60];
  int i;

  pl("Unspecified file found - enter description now.");
  nl();  
  sprintf(s, "%s : ",fn);
  if (!hangup) {
   i=0;
   while ( (!i) && (!hangup) ) {
    outstr(s);
    inputl(ds, 58);
    if (ds[0]==0) 
     continue;
    else
     i=1;
   }
  } else
     strcpy(ds,"-> CARRIER LOST <-");

  batch_upload5(fn, ds, dn);
}

/* add filename and description to online dir */
int batch_upload5(char *fn, char *ds, int dn)
{
  directoryrec d;
  uploadsrec u,u1;
  int i,i1,i2,i3,ok,f,fp;
  char s[81],s1[81],ff[81];
  long l;
  double ti;

  d=directories[dn];
  strcpy(s,fn);
  align(s);
  strcpy(u.filename,s);
  u.ownerusr=usernum;
  u.ownersys=0;
  u.numdloads=0;
  u.filetype=0;
  u.mask=0;
  strcpy(ff,d.path);
  strcat(ff,s);
  f=open(ff,O_RDONLY | O_BINARY);
  l=filelength(f);
  u.numbytes=l;
  close(f);
  strcpy(u.upby,nam1(&thisuser,usernum,syscfg.systemnumber));
  strcpy(u.date,date());
  if (d.mask & mask_PD)
    d.mask=mask_PD;
  strcpy(u.description, ds);
  ++thisuser.uploaded;
  thisuser.uk += (l+1023)/1024;
  time(&l);
  u.daten=l;
  for (i=numf; i>=1; i--) {
    SETREC(i);
    read(dlf,(void *)&u1,sizeof(uploadsrec));
    SETREC(i+1);
    write(dlf,(void *)&u1,sizeof(uploadsrec));
  }
  SETREC(1);
  write(dlf,(void *)&u,sizeof(uploadsrec));
  ++numf;
  u1.numbytes=numf;
  SETREC(0);
  write(dlf,(void *)&u1,sizeof(uploadsrec));
  ++status.uptoday;
  save_status();
  sprintf(s,"+Batch Upload = %s [%s] - %dk",u.filename,d.name,i3);
  sysoplog(s);
  return(1);
}
/* end of file BATCHUL.C */

----------------------------------------------------------------------------
POSSIBLE CHANGES
If you do not want Ymodem-G  - Remove Noted lines : 1, 3, 4, 5, 6
If you do not want Puma      - Remove Noted lines : 2, 7, 8, 9, 10
If you do not have a logoff countdown sequence called 'logoffmod'
which returns 1 to hangup -
  
  a. alter the return code and/or function name on line 14 
  
  OR
  
  a. Delete text '/Maybe' on line 11.
  b. Delete the character 'M' on line 12
  c. Delete Noted lines : 13, 14, 15 

LAST REMARKS
I have tested this modification for about two days with no problems.
If you find any problems send email to The Gatekeeper (1@2461). If you
have any specific custom software you need written AND are 
willing to pay for it, email me at the above address.  I ALSO request
that if you use this mod in any form, that you send me email letting
me know.
